type Post {
    id: Int!
    title: String!
    content: String
    person: Person
}

type Event {
    id: Int!
    title: String!
    description: String!
    date: Float!
}

type PagedEvent {
    entries: [Event],
    totalEntries: Int!
}

scalar Void

input PagingInput {
    sortColumn: String,
    sortAscending: Boolean,
    from: Int!,
    to: Int!
}
type Query {
    persons: [Person],
    posts: [Post],
    post(id: Int!): Post,
    person(id: Int!): Person,
    allEvents: [Event],
    events(paging: PagingInput): PagedEvent,
}

input PersonInput {
    name: String,
    age: Int
}

type Person{
    id: Int!
    name: String!
    age: Int!
    posts: [Post!]
}

type Mutation {
    updatePerson(id: Int, person: PersonInput): Person,
    insertPerson(person: PersonInput): Person,
    deletePerson(id: Int): Void,
    doPost(personId: Int, content: String, title: String): Post
}

type Subscription {
    personCreated(id: Int): Person
}

